## Development

### Quickstart

- `npm install`, the postinstall runs
  - `npm run rebuild`
    - might need to install some build tools depending on your platform
  - `npm run typeorm:migrate` for installing the database
- `npm run tsc` for backend
- `npm run webpack` for frontend
- `npm run dev`

### Git Commits

This project uses [Conventional Commits](https://www.conventionalcommits.or) with the following types:
- `feat`: features, if any part of your commit implements a new function, use this
- `fix`: bugfixes
- `doc`: documentation
- `refactor`: code refactoring
- `config`: changing configuration (linter, build process)
- `update`: updating dependencies and associated changes

Always try to split up your changes into coherent commits, a single commit should do a single thing.

### Database Migrations

Migrations are stored in [src/main/migrations](src/main/migrations) and handled by typeorm.

To auto-generate a migration:  
`node_modules/.bin/typeorm migration:generate -n <migration name> -c <connection name>`

To create an empty creation which can be filled with custom migration code:  
`node_modules/.bin/typeorm migration:create -n <migration name> -c <connection name>`

To run migrations:  
`node_modules/.bin/typeorm migration:run -c <connection name>`  
This is also pre-defined in the npm script `typeorm:migrate`.
